"{ Encoding: utf8 }"

"{ Package: 'stx:goodies/regression' }"

"{ NameSpace: RegressionTests }"

Object subclass:#Helper
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'tests-Regression-Helper'
!

!Helper class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    [author:]
        sr

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!Helper class methodsFor:'queries'!

isStcCompiledMethod:aMethod
    in:instance

    ^ self 
        isStcCompiledMethod:aMethod
        inClass:instance class
!

isStcCompiledMethod:aMethod
    inClass:aClass

    |compiledMethod|

    compiledMethod := aClass compiledMethodAt:aMethod.

    ^ (compiledMethod notNil 
    and:[compiledMethod byteCode isNil])
!

packageDirectoryForRegressionTests
    ^ self workDirectory / 'stx' / 'goodies' / 'regression'     
!

smalltalkDirectory
    ^ self workDirectory / 'stx' / 'projects' / 'smalltalk'     
!

workDirectory
    "return the directory one above the stx folder"

    |directoryOfStandaloneBinary dir parent|

    directoryOfStandaloneBinary := OperatingSystem nameOfSTXExecutable asFilename directory.
    "/ search for the directory above stx/goodies
    dir := directoryOfStandaloneBinary.
    [ 
        parent := dir directory.
        (dir pathName ~= parent pathName)
        and:[ (dir / 'stx' / 'goodies' / 'regression') exists not ]
    ] whileTrue:[
        dir := parent.
    ].
    (dir / 'stx/goodies/regression') exists ifFalse:[self error:'where am I?' ].
    ^ dir.
"/    (directoryOfStandaloneBinary pathName includesSubString:'quickSelfTest') ifTrue:[
"/        "this test is called by /stx/goodies/builder/quickSelfTest"
"/        dir := directoryOfStandaloneBinary.
"/        dir 
"/        ^ directoryOfStandaloneBinary 
"/            directory "/ /stx/goodies/builder/
"/            directory "/ /stx/goodies/  
"/            directory "/ /stx  
"/            directory "/ <one above>
"/    ].
"/
"/    ^ directoryOfStandaloneBinary directory directory directory 
! !

!Helper class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

